package com.github.wxiaoqi.security.admin.biz;

import com.github.wxiaoqi.security.admin.dto.AppUserPositionTempDTO;
import com.github.wxiaoqi.security.admin.entity.AppUserLogin;
import com.github.wxiaoqi.security.admin.entity.AppUserPosition;
import com.github.wxiaoqi.security.admin.entity.AppUserPositionTemp;
import com.github.wxiaoqi.security.admin.mapper.AppUserPositionTempMapper;
import com.github.wxiaoqi.security.common.biz.BaseBiz;
import com.github.wxiaoqi.security.common.msg.ObjectRestResponse;
import com.github.wxiaoqi.security.common.util.process.ResultCode;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import tk.mybatis.mapper.entity.Example;

import java.util.List;
import java.util.Objects;


/**
 * 用户身份职位表
 *
 * @author libin
 * @email 18178966185@163.com
 * @date 2019-07-09 10:00:42
 */
@Transactional
@Service
public class AppUserPositionTempBiz extends BaseBiz<AppUserPositionTempMapper, AppUserPositionTemp> {

    @Autowired
    private  AppUserDetailBiz detailBiz;

    @Autowired
    private  AppUserLoginBiz loginBiz;



    public ObjectRestResponse add(AppUserPositionTempDTO appUserPositionTempDTO) {
        if (appUserPositionTempDTO==null|| StringUtils.isBlank(appUserPositionTempDTO.getPhone()) ||StringUtils.isBlank(appUserPositionTempDTO.getName())
                ||appUserPositionTempDTO.getPositionId()==null||appUserPositionTempDTO.getPositionId()==0){
          return  ObjectRestResponse.createFailedResult(ResultCode.NOTEXIST_CODE,"参数不能为空");
        }
        String phone=appUserPositionTempDTO.getPhone();
        Integer id=appUserPositionTempDTO.getId()==null?0:appUserPositionTempDTO.getId();
        Example example=new Example(AppUserPositionTempBiz.class);
        example.createCriteria().andEqualTo("phone",phone).andNotEqualTo("id",id).andEqualTo("isDel",0);
        List<AppUserPositionTemp> list=selectByExample(example);
        if (list.size()>0){
            return  ObjectRestResponse.createFailedResult(ResultCode.EXIST_CODE,"手机号码已存在");
        }
        Integer userId=0;
        AppUserLogin userLogin=loginBiz.checkeUserLogin(phone);
        if (userLogin!=null){
            userId=userLogin.getId();
        }
        AppUserPositionTemp userPositionTemp = new AppUserPositionTemp();
        BeanUtils.copyProperties(appUserPositionTempDTO,userPositionTemp);
        userPositionTemp.setUserId(userId);
        //编辑
        if (id==null||id==0){
            updateSelectiveById(userPositionTemp);
        }else { //保存
            insertSelective(userPositionTemp);
        }
        return ObjectRestResponse.succ();
    }

    public void updateAppuserPostionStatusById(Integer id, int status) {
        AppUserPositionTemp appUserPositionTemp = new AppUserPositionTemp();
        appUserPositionTemp.setId(id);
        appUserPositionTemp.setIsDel(status);
        mapper.updateByPrimaryKeySelective(appUserPositionTemp);
    }
}